'use strict';
angular.module('aom.services')
  .factory('aomNotificationSrv', function ($state, aomResourcesSrv, aomLogSrv, constants, appConfig) {
    var notification = {},
      limits = {};

    notification.data = {
      displayUpdateMessageOnHeader: false
    };

    function showToast(message) {
      if (window.cordova) {
        AOMNotification.show(message, appConfig.name);
      } else {
        alert(message);
      }
    }

    function notify(message, persistent) {
      aomLogSrv.log({ message: message }, aomLogSrv.levels.medium, aomLogSrv.severities.info);
      if (persistent) {
        notification.data.displayUpdateMessageOnHeader = true;
      }
      showToast(message);
    }

    notification.notify = function (message, persistent, limit) {
      if (limit && limit.name && limit.maxFreq) {
        if (limits[limit.name]) {
          var now = new Date();
          if ((now - limits[limit.name].lastShown) < limit.maxFreq) {
            return 'limitExceeded';
          }
        } else {
          limits[limit.name] = {};
        }
        limits[limit.name].lastShown = now;
      }
      notify(message, persistent);
    };

    return notification;
  });