'use strict';
angular.module('aom.services')
  .factory('aomPrintingSrv', function ($q, $cordovaPrinter, aomFileSystemSrv, aomLogSrv) {
    var printingSrv = {};

    printingSrv.printFile = function (filename) {

      return $cordovaPrinter.isAvailable()
        .then(function () {
          return aomFileSystemSrv.base64String(filename);
        })
        .then(function (base64String) {
          var printingString = '<html><img src="' + base64String + '">';
          return $cordovaPrinter.print(printingString);
        })
        .catch(function (err) {
          aomLogSrv.log({ message: 'Failed to print', error: err }, aomLogSrv.levels.high, aomLogSrv.severities.err);
          return $q.reject(err);
        });
    };

    return printingSrv;
  });
